(function ($) {
  'use strict';

  Drupal.behaviors.yasmCounter = {
    attach: function (context, settings) {
      var $counts = $('.yasm-counters .count', context);

      if ($counts.length === 0) {
        return;
      }

      function startCounter($element, duration) {
        $element.addClass('counter-on');
        $element.prop('contador', 0).animate(
            { contador: $element.text() },
            {
              duration: duration,
              easing: 'swing',
              step: function (now) {
                $element.text(Math.ceil(now));
              },
              complete: function () {
                $element.removeClass('counter-on');
              }
            }
        );
      }

      var $toInit;
      if (typeof $counts.once === 'function') {
        $toInit = $counts.once('yasm-counter');
      } else {
        $toInit = $counts.not('.yasm-counter-initialized').addClass('yasm-counter-initialized');
      }

      $toInit.each(function () {
        var $el = $(this);
        var value = parseInt($el.text(), 10);
        if (value > 0) {
          startCounter($el, 5000);
        }
      });

      $counts.on('mouseenter', function () {
        var $el = $(this);
        if (!$el.hasClass('counter-on')) {
          var value = parseInt($el.text(), 10);
          if (value > 0) {
            startCounter($el, 500);
          }
        }
      });
    }
  };

}(jQuery));
